using UnityEngine;
using System.Collections;

public class EndZone : MonoBehaviour {

    public int NumRequiredSheep = 1;
    int m_iSheepsCollected;
    GameObject m_Herd;

    public Texture2D SheepTex;
    public Texture2D MissingSheepTex;
    public Texture2D SignWinTex;
    public Texture2D SignGameOverTex;
    public AudioClip CollectSheep;
    public AudioClip WinLevel;
    public AudioClip GameOver;

    bool hasplayedmelody = false;

	// Use this for initialization
	void Start () {
        m_iSheepsCollected = 0;
        m_Herd = GameObject.Find("SheepHerd");
        hasplayedmelody = false;
    }
	
	// Update is called once per frame
	void Update () {
	
	}

    void OnTriggerEnter(Collider other)
    {
        if (other.gameObject.tag == "Sheep")
        {
            SheepControl sheep = other.gameObject.GetComponent<SheepControl>();
            if (sheep)
            {
            }
        }
    }

    void OnTriggerExit(Collider other)
    {
        if (other.gameObject.tag == "Sheep")
        {
            SheepControl sheep = other.gameObject.GetComponent<SheepControl>();
            if (sheep)
            {
                sheep.rigidbody.drag = 10;
            }
        }
    }

    void OnTriggerStay(Collider other)
    {
        if (other.gameObject.tag == "Sheep")
        {
            SheepControl sheep = other.gameObject.GetComponent<SheepControl>();
            if (sheep && !sheep.wolf && sheep.rigidbody.drag <= 200)
            {
                sheep.rigidbody.drag += 300 * Time.deltaTime;
                if (sheep.rigidbody.drag >= 200)
                {
                    if (m_iSheepsCollected + 1 < NumRequiredSheep)
                    {
                        audio.PlayOneShot(CollectSheep);
                    }                    
                    Destroy(sheep.gameObject);
                    m_iSheepsCollected += 1;
                    if (!hasplayedmelody && m_iSheepsCollected == NumRequiredSheep)
                    {
                        hasplayedmelody = true;
                        GameObject.Find("Music").audio.Stop();
                        GameObject.Find("Music").audio.PlayOneShot(WinLevel);
                    }
                }
            }
        }

        if (!hasplayedmelody && !CanWin())
        {
            hasplayedmelody = true;
            GameObject.Find("Music").audio.Stop();
            GameObject.Find("Music").audio.PlayOneShot(GameOver);
        }
    }

    bool CanWin()
    {
        int iLiveSheep = 0;
        if (m_Herd)
        {
            SheepControl[] sheeplist = m_Herd.GetComponentsInChildren<SheepControl>();
            foreach (SheepControl sheep in sheeplist)
            {
                if (!sheep.wolf)
                {
                    iLiveSheep += 1;
                }
            }
        }
        return iLiveSheep + m_iSheepsCollected >= NumRequiredSheep;
    }

    void OnGUI()
    {
        // Draw collected sheep on screen
        {
            float fWidth = Screen.width-80;
            float fHeight = 100.0f; // SheepTex.height;
            GUILayout.BeginArea(new Rect(40, Screen.height - fHeight - 40, fWidth, fHeight));
            GUILayout.BeginHorizontal();
            for (int i = 0; i < m_iSheepsCollected; i++)
            {
                GUI.Label(new Rect(i * 48.0f,0,60.0f,70.0f),SheepTex);
            }
            for (int i = m_iSheepsCollected; i < NumRequiredSheep; i++)
            {
                GUI.Label(new Rect(i * 48.0f, 0, 70.0f, 70.0f), MissingSheepTex);
            }
            GUILayout.FlexibleSpace();
            GUILayout.EndHorizontal();
            GUILayout.EndArea();
        }

        if (m_iSheepsCollected >= NumRequiredSheep)
        {
            GameObject player = GameObject.FindGameObjectWithTag("Player");
            player.GetComponent<PlayerControl>().AllowControl = false;
            // You win!
            float fWidth = 512;
            float fHeight = 256;
            GUILayout.BeginArea(new Rect((Screen.width - fWidth) * 0.5f, (Screen.height - fHeight) * 0.5f, fWidth, fHeight));
            GUILayout.BeginVertical();
           // GUILayout.Label(SignWinTex);
            GUILayout.Label("Congratulations. You saved all the sheep you needed");
            if (GUILayout.Button("Play again"))
            {
                // Find a new level
                Application.LoadLevel(Application.loadedLevel);
            }
            if (GUILayout.Button("Back to menu"))
            {
                // Restart
                Application.LoadLevel("menu");
            }
            GUILayout.EndVertical();
            GUILayout.EndArea();
        }
        else if (!CanWin())
        {
            GameObject player = GameObject.FindGameObjectWithTag("Player");
            player.GetComponent<PlayerControl>().AllowControl = false;
            float fWidth = 512;
            float fHeight = 256;
            GUILayout.BeginArea(new Rect((Screen.width - fWidth) * 0.5f, (Screen.height - fHeight) * 0.5f, fWidth, fHeight));
            GUILayout.BeginVertical();
         //   GUILayout.Label(SignGameOverTex);
//            GUILayout.BeginHorizontal();
            GUILayout.Label("Game over. There are not enough sheep left alive.");
            if (GUILayout.Button("Restart level"))
            {
                // Restart
                Application.LoadLevel(Application.loadedLevel);
            }
            if (GUILayout.Button("Back to menu"))
            {
                // Restart
                Application.LoadLevel("menu");
            }
  //          GUILayout.EndHorizontal();
            GUILayout.EndVertical();
            GUILayout.EndArea();
        }
    }
}
