using UnityEngine;
using System.Collections;

public class ParticleEffect : MonoBehaviour {



    float m_fTime;
    public float m_fState0Length = 0.3f;
    public float m_fState1Length = 1.0f;
    public float m_fState2Length = 0.3f;

    public bool Floating = false;

    int m_iState;


	// Use this for initialization
	void Start () {
        m_iState = 0;
        m_fTime = 0.0f;
	}
	
	// Update is called once per frame
	void Update () 
    {
        if (Floating)
        {
            Vector3 v = transform.position;
            v.y += Time.deltaTime * 1.0f;
            transform.position = v;
        }

        switch (m_iState)
        {
            case 0: // Grow
                {
                    float fFrac = Mathf.Clamp(m_fTime / m_fState0Length, 0.0f, 1.0f);
                    fFrac = 0.2f + 0.8f * fFrac * fFrac;
                    transform.localScale = new Vector3(fFrac, 1.0f, fFrac);
                    transform.rotation = Quaternion.AngleAxis((1.0f - fFrac) * 35.0f, Vector3.up);
                }
                break;
            case 1: // Stay
                {
                }
                break;
            case 2: // Fade
                {
                    float fFrac = 1.0f - ((m_fTime - (m_fState0Length + m_fState1Length)) / m_fState2Length);
                    Renderer render = GetComponentInChildren<Renderer>();
                    render.material.color = new UnityEngine.Color(1, 1, 1, fFrac);
                }
                break;
        }

        m_fTime += Time.deltaTime;
        switch (m_iState)
        {
            case 0:
                if (m_fTime > m_fState0Length)
                {
                    m_iState = 1;
                }
                break;
            case 1:
                if (m_fTime > m_fState0Length + m_fState1Length)
                {
                    m_iState = 2;
                }
                break;
            case 2:
                if (m_fTime > m_fState0Length + m_fState1Length + m_fState2Length)
                {
                    Destroy(gameObject);
                }
                break;
        }
	
	}


}
